<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLiabilityItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLiabilityItem
 * @subpackage Arrays
 */
class ArrayOfLiabilityItem extends AbstractStructArrayBase
{
    /**
     * The LiabilityItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\LiabilityItem[]
     */
    public $LiabilityItem;
    /**
     * Constructor method for ArrayOfLiabilityItem
     * @uses ArrayOfLiabilityItem::setLiabilityItem()
     * @param \patest\StructType\LiabilityItem[] $liabilityItem
     */
    public function __construct(array $liabilityItem = array())
    {
        $this
            ->setLiabilityItem($liabilityItem);
    }
    /**
     * Get LiabilityItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\LiabilityItem[]|null
     */
    public function getLiabilityItem()
    {
        return isset($this->LiabilityItem) ? $this->LiabilityItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLiabilityItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLiabilityItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLiabilityItemForArrayConstraintsFromSetLiabilityItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLiabilityItemLiabilityItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfLiabilityItemLiabilityItemItem instanceof \patest\StructType\LiabilityItem) {
                $invalidValues[] = is_object($arrayOfLiabilityItemLiabilityItemItem) ? get_class($arrayOfLiabilityItemLiabilityItemItem) : sprintf('%s(%s)', gettype($arrayOfLiabilityItemLiabilityItemItem), var_export($arrayOfLiabilityItemLiabilityItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LiabilityItem property can only contain items of type \patest\StructType\LiabilityItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LiabilityItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LiabilityItem[] $liabilityItem
     * @return \patest\ArrayType\ArrayOfLiabilityItem
     */
    public function setLiabilityItem(array $liabilityItem = array())
    {
        // validation for constraint: array
        if ('' !== ($liabilityItemArrayErrorMessage = self::validateLiabilityItemForArrayConstraintsFromSetLiabilityItem($liabilityItem))) {
            throw new \InvalidArgumentException($liabilityItemArrayErrorMessage, __LINE__);
        }
        if (is_null($liabilityItem) || (is_array($liabilityItem) && empty($liabilityItem))) {
            unset($this->LiabilityItem);
        } else {
            $this->LiabilityItem = $liabilityItem;
        }
        return $this;
    }
    /**
     * Add item to LiabilityItem value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LiabilityItem $item
     * @return \patest\ArrayType\ArrayOfLiabilityItem
     */
    public function addToLiabilityItem(\patest\StructType\LiabilityItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\LiabilityItem) {
            throw new \InvalidArgumentException(sprintf('The LiabilityItem property can only contain items of type \patest\StructType\LiabilityItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LiabilityItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\LiabilityItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\LiabilityItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\LiabilityItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\LiabilityItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\LiabilityItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LiabilityItem
     */
    public function getAttributeName()
    {
        return 'LiabilityItem';
    }
}
